libxkbcommon: Keymap Components

libxkbcommon 0.5.0

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Typedefs | Functions
Keymap Components

## Typedefs
typedef void(* | xkb_keymap::xkb_keymap_key_iter_t )(struct xkb_keymap *keymap, xkb_keycode_t key, void *data)

## Functions
xkb_keycode_t | xkb_keymap::xkb_keymap_min_keycode (struct xkb_keymap *keymap)
xkb_keycode_t | xkb_keymap::xkb_keymap_max_keycode (struct xkb_keymap *keymap)
void | xkb_keymap::xkb_keymap_key_for_each (struct xkb_keymap *keymap, xkb_keymap_key_iter_t iter, void *data)
xkb_mod_index_t | xkb_keymap::xkb_keymap_num_mods (struct xkb_keymap *keymap)
const char * | xkb_keymap::xkb_keymap_mod_get_name (struct xkb_keymap *keymap, xkb_mod_index_t idx)
xkb_mod_index_t | xkb_keymap::xkb_keymap_mod_get_index (struct xkb_keymap *keymap, const char *name)
xkb_layout_index_t | xkb_keymap::xkb_keymap_num_layouts (struct xkb_keymap *keymap)
const char * | xkb_keymap::xkb_keymap_layout_get_name (struct xkb_keymap *keymap, xkb_layout_index_t idx)
xkb_layout_index_t | xkb_keymap::xkb_keymap_layout_get_index (struct xkb_keymap *keymap, const char *name)
xkb_led_index_t | xkb_keymap::xkb_keymap_num_leds (struct xkb_keymap *keymap)
const char * | xkb_keymap::xkb_keymap_led_get_name (struct xkb_keymap *keymap, xkb_led_index_t idx)
xkb_led_index_t | xkb_keymap::xkb_keymap_led_get_index (struct xkb_keymap *keymap, const char *name)
xkb_layout_index_t | xkb_keymap::xkb_keymap_num_layouts_for_key (struct xkb_keymap *keymap, xkb_keycode_t key)
xkb_level_index_t | xkb_keymap::xkb_keymap_num_levels_for_key (struct xkb_keymap *keymap, xkb_keycode_t key, xkb_layout_index_t layout)
int | xkb_keymap::xkb_keymap_key_get_syms_by_level (struct xkb_keymap *keymap, xkb_keycode_t key, xkb_layout_index_t layout, xkb_level_index_t level, const xkb_keysym_t **syms_out)
int | xkb_keymap::xkb_keymap_key_repeats (struct xkb_keymap *keymap, xkb_keycode_t key)

## Detailed Description

Enumeration of state components in a keymap.

## Typedef Documentation

typedef void(* xkb_keymap_key_iter_t)(struct xkb_keymap *keymap, xkb_keycode_t key, void *data)

The iterator used by xkb_keymap_key_for_each().

See also
  xkb_keymap_key_for_each

Since
  0.3.1

## Function Documentation

xkb_keycode_t xkb_keymap_min_keycode | ( | struct xkb_keymap * | keymap | ) |

Get the minimum keycode in the keymap.

See also
  xkb_keycode_t

Since
  0.3.1

xkb_keycode_t xkb_keymap_max_keycode | ( | struct xkb_keymap * | keymap | ) |

Get the maximum keycode in the keymap.

See also
  xkb_keycode_t

Since
  0.3.1

void xkb_keymap_key_for_each | ( | struct xkb_keymap * | keymap,
|  | xkb_keymap_key_iter_t | iter,
|  | void * | data
| ) |  |

Run a specified function for every valid keycode in the keymap.

If a keymap is sparse, this function may be called fewer than (max_keycode - min_keycode + 1) times.

See also
  xkb_keymap_min_keycode() xkb_keymap_max_keycode() xkb_keycode_t

Since
  0.3.1

xkb_mod_index_t xkb_keymap_num_mods | ( | struct xkb_keymap * | keymap | ) |

Get the number of modifiers in the keymap.

See also
  xkb_mod_index_t

const char * xkb_keymap_mod_get_name | ( | struct xkb_keymap * | keymap,
|  | xkb_mod_index_t | idx
| ) |  |

Get the name of a modifier by index.

Returns
  The name. If the index is invalid, returns NULL.

See also
  xkb_mod_index_t

xkb_mod_index_t xkb_keymap_mod_get_index | ( | struct xkb_keymap * | keymap,
|  | const char * | name
| ) |  |

Get the index of a modifier by name.

Returns
  The index. If no modifier with this name exists, returns XKB_MOD_INVALID.

See also
  xkb_mod_index_t

xkb_layout_index_t xkb_keymap_num_layouts | ( | struct xkb_keymap * | keymap | ) |

Get the number of layouts in the keymap.

See also
  xkb_layout_index_t xkb_rule_names xkb_keymap_num_layouts_for_key()

const char * xkb_keymap_layout_get_name | ( | struct xkb_keymap * | keymap,
|  | xkb_layout_index_t | idx
| ) |  |

Get the name of a layout by index.

Returns
  The name. If the index is invalid, or the layout does not have a name, returns NULL.

See also
  xkb_layout_index_t

xkb_layout_index_t xkb_keymap_layout_get_index | ( | struct xkb_keymap * | keymap,
|  | const char * | name
| ) |  |

Get the index of a layout by name.

Returns
  The index. If no layout exists with this name, returns XKB_LAYOUT_INVALID. If more than one layout in the keymap has this name, returns the lowest index among them.

xkb_led_index_t xkb_keymap_num_leds | ( | struct xkb_keymap * | keymap | ) |

Get the number of LEDs in the keymap.

Warning
  The range [ 0...xkb_keymap_num_leds() ) includes all of the LEDs in the keymap, but may also contain inactive LEDs. When iterating over this range, you need the handle this case when calling functions such as xkb_keymap_led_get_name() or xkb_state_led_index_is_active().

See also
  xkb_led_index_t

const char * xkb_keymap_led_get_name | ( | struct xkb_keymap * | keymap,
|  | xkb_led_index_t | idx
| ) |  |

Get the name of a LED by index.

Returns
  The name. If the index is invalid, returns NULL.

xkb_led_index_t xkb_keymap_led_get_index | ( | struct xkb_keymap * | keymap,
|  | const char * | name
| ) |  |

Get the index of a LED by name.

Returns
  The index. If no LED with this name exists, returns XKB_LED_INVALID.

xkb_layout_index_t xkb_keymap_num_layouts_for_key | ( | struct xkb_keymap * | keymap,
|  | xkb_keycode_t | key
| ) |  |

Get the number of layouts for a specific key.

This number can be different from xkb_keymap_num_layouts(), but is always smaller. It is the appropriate value to use when iterating over the layouts of a key.

See also
  xkb_layout_index_t

xkb_level_index_t xkb_keymap_num_levels_for_key | ( | struct xkb_keymap * | keymap,
|  | xkb_keycode_t | key,
|  | xkb_layout_index_t | layout
| ) |  |

Get the number of shift levels for a specific key and layout.

If `layout` is out of range for this key (that is, larger or equal to the value returned by xkb_keymap_num_layouts_for_key()), it is brought back into range in a manner consistent with xkb_state_key_get_layout().

See also
  xkb_level_index_t

int xkb_keymap_key_get_syms_by_level | ( | struct xkb_keymap * | keymap,
|  | xkb_keycode_t | key,
|  | xkb_layout_index_t | layout,
|  | xkb_level_index_t | level,
|  | const xkb_keysym_t ** | syms_out
| ) |  |

Get the keysyms obtained from pressing a key in a given layout and shift level.

This function is like xkb_state_key_get_syms(), only the layout and shift level are not derived from the keyboard state but are instead specified explicitly.

Parameters

  [in] | keymap | The keymap.
  [in] | key | The keycode of the key.
  [in] | layout | The layout for which to get the keysyms.
  [in] | level | The shift level in the layout for which to get the keysyms. This must be smaller than: xkb_keymap_num_levels_for_key(keymap, key)
  [out] | syms_out | An immutable array of keysyms corresponding to the key in the given layout and shift level.

If `layout` is out of range for this key (that is, larger or equal to the value returned by xkb_keymap_num_layouts_for_key()), it is brought back into range in a manner consistent with xkb_state_key_get_layout().

Returns
  The number of keysyms in the syms_out array. If no keysyms are produced by the key in the given layout and shift level, returns 0 and sets syms_out to NULL.

See also
  xkb_state_key_get_syms()

int xkb_keymap_key_repeats | ( | struct xkb_keymap * | keymap,
|  | xkb_keycode_t | key
| ) |  |

Determine whether a key should repeat or not.

A keymap may specify different repeat behaviors for different keys. Most keys should generally exhibit repeat behavior; for example, holding the 'a' key down in a text editor should normally insert a single 'a' character every few milliseconds, until the key is released. However, there are keys which should not or do not need to be repeated. For example, repeating modifier keys such as Left/Right Shift or Caps Lock is not generally useful or desired.

Returns
  1 if the key should repeat, 0 otherwise.